/* loc.c 154d */
#include "all.h"

Value*
allocate(Value v)
{
    Value *loc;

    pushroot(mkStackvalueroot(&v));
    loc = allocloc();
    assert(loc != NULL);
    poproot(mkStackvalueroot(&v));
    *loc = v;
    return loc;
}
/* loc.c 155a */
extern void printfinalstats(void);   /*OMIT*/
void initallocate(Env **envp) 
{
    atexit(printfinalstats);         /*OMIT*/
    pushroot(mkEnvroot(envp));
    *envp = NULL;
}
/* loc.c 155b */
void resetallocate(Env **envp) 
{
    resetrootstack();
    pushroot(mkEnvroot(envp));
}
/* loc.c 555c */
int
gammadesired(int defaultval, int minimum)
{
    Value *gloc;

    assert(rootstacksize > 0 && rootstack[0].ty == ENVROOT);
    gloc = find(strtoname("&gamma-desired"), *rootstack[0].u.envroot);
    if (gloc && gloc->ty == NUM)
        return gloc->u.num > minimum ? gloc->u.num : minimum;
    else
        return defaultval;
}
/* loc.c 555f */
Value validate(Value v) {
    assert(v.ty != INVALID);
    return v;
}
