#include "all.h"
int
lengthEL(Explist* l)
{
    int n;

    for(n=0; l; n++)
        l=l->tl;

    return n;
}

int
lengthPL(Parlist* l)
{
    int n;

    for(n=0; l; n++)
        l=l->tl;

    return n;
}

int
lengthVL(Valuelist* l)
{
    int n;

    for(n=0; l; n++)
        l=l->tl;

    return n;
}

int
lengthFL(Funlist* l)
{
    int n;

    for(n=0; l; n++)
        l=l->tl;

    return n;
}

int
lengthNL(Namelist* l)
{
    int n;

    for(n=0; l; n++)
        l=l->tl;

    return n;
}

Explist*
mkEL(Exp *hd, Explist *tl)
{
    Explist *l;

    l = malloc(sizeof *l);
    assert(l != NULL);

    l->hd = hd;
    l->tl = tl;

    return l;
}

Parlist*
mkPL(Par *hd, Parlist *tl)
{
    Parlist *l;

    l = malloc(sizeof *l);
    assert(l != NULL);

    l->hd = hd;
    l->tl = tl;

    return l;
}

Valuelist*
mkVL(Value hd, Valuelist *tl)
{
    Valuelist *l;

    l = malloc(sizeof *l);
    assert(l != NULL);

    l->hd = hd;
    l->tl = tl;

    return l;
}

Funlist*
mkFL(Fun hd, Funlist *tl)
{
    Funlist *l;

    l = malloc(sizeof *l);
    assert(l != NULL);

    l->hd = hd;
    l->tl = tl;

    return l;
}

Namelist*
mkNL(Name *hd, Namelist *tl)
{
    Namelist *l;

    l = malloc(sizeof *l);
    assert(l != NULL);

    l->hd = hd;
    l->tl = tl;

    return l;
}

Exp*
nthEL(Explist* l, unsigned n)
{
    unsigned i;

    for(i=0; l && i<n; i++)
        l=l->tl;

    assert(l != NULL);
    return l->hd;
}

Par*
nthPL(Parlist* l, unsigned n)
{
    unsigned i;

    for(i=0; l && i<n; i++)
        l=l->tl;

    assert(l != NULL);
    return l->hd;
}

Value
nthVL(Valuelist* l, unsigned n)
{
    unsigned i;

    for(i=0; l && i<n; i++)
        l=l->tl;

    assert(l != NULL);
    return l->hd;
}

Fun
nthFL(Funlist* l, unsigned n)
{
    unsigned i;

    for(i=0; l && i<n; i++)
        l=l->tl;

    assert(l != NULL);
    return l->hd;
}

Name*
nthNL(Namelist* l, unsigned n)
{
    unsigned i;

    for(i=0; l && i<n; i++)
        l=l->tl;

    assert(l != NULL);
    return l->hd;
}

void
printexplist(va_list *va)
{
    Explist* l;

    for(l=va_arg(*va, Explist*); l; l=l->tl)
        print("%e%s", l->hd, l->tl?" ":"");
}

void
printparlist(va_list *va)
{
    Parlist* l;

    for(l=va_arg(*va, Parlist*); l; l=l->tl)
        print("%p%s", l->hd, l->tl?" ":"");
}

void
printvaluelist(va_list *va)
{
    Valuelist* l;

    for(l=va_arg(*va, Valuelist*); l; l=l->tl)
        print("%v%s", l->hd, l->tl?" ":"");
}

void
printfunlist(va_list *va)
{
    Funlist* l;

    for(l=va_arg(*va, Funlist*); l; l=l->tl)
        print("%f%s", l->hd, l->tl?" ":"");
}

void
printnamelist(va_list *va)
{
    Namelist* l;

    for(l=va_arg(*va, Namelist*); l; l=l->tl)
        print("%n%s", l->hd, l->tl?" ":"");
}

