#include "all.h"
Userfun
mkUserfun(Namelist *formals, Exp *body)
{
    Userfun n;

    n.formals = formals;
    n.body = body;
    return n;
}

Toplevel*
mkExp(Exp *x)
{
    Toplevel *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = EXP;
    n->u.exp = x;
    return n;
}

Toplevel*
mkVal(Name *name, Exp *exp)
{
    Toplevel *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = VAL;
    n->u.val.name = name;
    n->u.val.exp = exp;
    return n;
}

Toplevel*
mkDefine(Name *name, Userfun userfun)
{
    Toplevel *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = DEFINE;
    n->u.define.name = name;
    n->u.define.userfun = userfun;
    return n;
}

Toplevel*
mkUse(Name *x)
{
    Toplevel *n;

    n = malloc(sizeof *n);
    assert(n != NULL);

    n->ty = USE;
    n->u.use = x;
    return n;
}

